// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'DBFilter.pas' rev: 6.00

#ifndef DBFilterHPP
#define DBFilterHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <DBTables.hpp>	// Pascal unit
#include <DB.hpp>	// Pascal unit
#include <BDE.hpp>	// Pascal unit
#include <ExtCtrls.hpp>	// Pascal unit
#include <StdCtrls.hpp>	// Pascal unit
#include <Menus.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Dbfilter
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TFilterLogicCond { flAnd, flOr };
#pragma option pop

typedef Db::TFilterOption TDBFilterOption;

typedef TFilterOptions TDBFilterOptions;
;

typedef bool __fastcall (__closure *TFilterEvent)(System::TObject* Sender, Db::TDataSet* DataSet);

struct TDataSetStorage
{
	bool FBof;
	bool FEof;
	Db::TDataSetState State;
	bool CanModify;
	Db::TDataSetNotifyEvent BeforePost;
	Db::TDataSetNotifyEvent BeforeCancel;
	Db::TDataSetNotifyEvent BeforeInsert;
	Db::TDataSetNotifyEvent BeforeEdit;
} ;

class DELPHICLASS TRxDBFilter;
class PASCALIMPLEMENTATION TRxDBFilter : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	System::TObject* FParser;
	Db::TDataLink* FDataLink;
	bool FIgnoreDataEvents;
	Word FPriority;
	Db::TFilterOptions FOptions;
	TFilterLogicCond FLogicCond;
	Classes::TStrings* FFilter;
	Bde::_hDBIObj *FExprHandle;
	Bde::_hDBIObj *FFuncHandle;
	Bde::_hDBIObj *FDataHandle;
	bool FActive;
	bool FCaptured;
	bool FStreamedActive;
	bool FActivating;
	TDataSetStorage FStorage;
	TFilterEvent FOnFiltering;
	Classes::TNotifyEvent FOnActivate;
	Classes::TNotifyEvent FOnDeactivate;
	Classes::TNotifyEvent FOnSetCapture;
	Classes::TNotifyEvent FOnReleaseCapture;
	void __fastcall SetDataSource(Db::TDataSource* Value);
	Db::TDataSource* __fastcall GetDataSource(void);
	bool __fastcall BuildTree(void);
	void __fastcall DestroyTree(void);
	void __fastcall SetFilter(Classes::TStrings* Value);
	void __fastcall SetOptions(Db::TFilterOptions Value);
	void __fastcall SetOnFiltering(const TFilterEvent Value);
	void __fastcall SetPriority(Word Value);
	void __fastcall SetLogicCond(TFilterLogicCond Value);
	char * __fastcall GetFilterText(void);
	void __fastcall FilterChanged(System::TObject* Sender);
	Bde::hDBIFilter __fastcall CreateExprFilter(void);
	Bde::hDBIFilter __fastcall CreateFuncFilter(void);
	void __fastcall DropFilters(void);
	void __fastcall SetFilterHandle(Bde::hDBIFilter &Filter, Bde::hDBIFilter Value);
	void __fastcall RecreateExprFilter(void);
	void __fastcall RecreateFuncFilter(void);
	void __fastcall ActivateFilters(void);
	void __fastcall DeactivateFilters(void);
	short __stdcall RecordFilter(void * RecBuf, int RecNo);
	void __fastcall BeforeDataPost(Db::TDataSet* DataSet);
	void __fastcall BeforeDataChange(Db::TDataSet* DataSet);
	void __fastcall BeforeDataCancel(Db::TDataSet* DataSet);
	void __fastcall SetActive(bool Value);
	
protected:
	virtual void __fastcall Loaded(void);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation);
	DYNAMIC void __fastcall DoActivate(void);
	DYNAMIC void __fastcall DoDeactivate(void);
	virtual void __fastcall ActiveChanged(void);
	
public:
	__fastcall virtual TRxDBFilter(Classes::TComponent* AOwner);
	__fastcall virtual ~TRxDBFilter(void);
	virtual void __fastcall Update(void);
	void __fastcall UpdateFuncFilter(void);
	void __fastcall Activate(void);
	void __fastcall Deactivate(void);
	void __fastcall SetCapture(void);
	void __fastcall ReleaseCapture(void);
	void __fastcall ReadCaptureControls(void);
	__property bool Captured = {read=FCaptured, nodefault};
	__property Bde::hDBIFilter Handle = {read=FExprHandle};
	__property Bde::hDBIFilter ExprFilter = {read=FExprHandle};
	__property Bde::hDBIFilter FuncFilter = {read=FFuncHandle};
	
__published:
	__property bool Active = {read=FActive, write=SetActive, default=0};
	__property Db::TDataSource* DataSource = {read=GetDataSource, write=SetDataSource};
	__property Classes::TStrings* Filter = {read=FFilter, write=SetFilter};
	__property TFilterLogicCond LogicCond = {read=FLogicCond, write=SetLogicCond, default=0};
	__property Db::TFilterOptions Options = {read=FOptions, write=SetOptions, default=0};
	__property Word Priority = {read=FPriority, write=SetPriority, default=0};
	__property Classes::TNotifyEvent OnActivate = {read=FOnActivate, write=FOnActivate};
	__property Classes::TNotifyEvent OnDeactivate = {read=FOnDeactivate, write=FOnDeactivate};
	__property TFilterEvent OnFiltering = {read=FOnFiltering, write=SetOnFiltering};
	__property Classes::TNotifyEvent OnSetCapture = {read=FOnSetCapture, write=FOnSetCapture};
	__property Classes::TNotifyEvent OnReleaseCapture = {read=FOnReleaseCapture, write=FOnReleaseCapture};
};


class DELPHICLASS EFilterError;
class PASCALIMPLEMENTATION EFilterError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	#pragma option push -w-inl
	/* Exception.Create */ inline __fastcall EFilterError(const AnsiString Msg) : Sysutils::Exception(Msg) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EFilterError(const AnsiString Msg, const System::TVarRec * Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EFilterError(int Ident)/* overload */ : Sysutils::Exception(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EFilterError(int Ident, const System::TVarRec * Args, const int Args_Size)/* overload */ : Sysutils::Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EFilterError(const AnsiString Msg, int AHelpContext) : Sysutils::Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EFilterError(const AnsiString Msg, const System::TVarRec * Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EFilterError(int Ident, int AHelpContext)/* overload */ : Sysutils::Exception(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EFilterError(System::PResStringRec ResStringRec, const System::TVarRec * Args, const int Args_Size, int AHelpContext)/* overload */ : Sysutils::Exception(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EFilterError(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE void __fastcall DropAllFilters(Db::TDataSet* DataSet);

}	/* namespace Dbfilter */
using namespace Dbfilter;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// DBFilter
